/*--------------------------------------------------------------------------------------+
|
|     $Source: MstnExamples/View/DisplayRule/displayrule.cpp $
|
|  $Copyright: (c) 2018 Bentley Systems, Incorporated. All rights reserved. $
|
+--------------------------------------------------------------------------------------*/
#include "displayruleincludes.h"
#include "displayruleutils.h"

/*---------------------------------------------------------------------------------**//**
* @description  Map key-in to function
* Commands
+---------------+---------------+---------------+---------------+---------------+------*/
static MdlCommandNumber s_commandNumbers[] =
    {
    { (CmdHandler) DisplayRuleUtils::CreateDisplayRuleSet,                      CMD_DISPLAYRULE_CREATE_RULESET },
    { (CmdHandler) DisplayRuleUtils::CreateDisplayRule,                         CMD_DISPLAYRULE_CREATE_RULE },
    { (CmdHandler) DisplayRuleUtils::CreateDisplayRuleItemType,               	CMD_DISPLAYRULE_CREATE_RULEITEMTYPE },
    { (CmdHandler) DisplayRuleUtils::DeleteDisplayRuleSet,                      CMD_DISPLAYRULE_DELETE_RULESET },
    { (CmdHandler) DisplayRuleUtils::DeleteDisplayRule,                         CMD_DISPLAYRULE_DELETE_RULE },
    { (CmdHandler) DisplayRuleUtils::ModifyDisplayRuleAndActions,               CMD_DISPLAYRULE_MODIFY_RULE },
    { (CmdHandler) DisplayRuleUtils::ReadDisplayRuleFromRuleSet,                CMD_DISPLAYRULE_READ_RULE },
    // end of list
    0
    };

/*---------------------------------------------------------------------------------**//**
* @description  MdlMain
* @param        argc      The number of command line parameters sent to the application.
* @param        argv[]    The array of strings sent to the application on the command line.
* @bsimethod                                                              Bentley Systems
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" void MdlMain (int argc, WCharCP argv[])
    {
    /*	Open the resource file	*/
    RscFileHandle rfHandle;
    mdlResource_openFile (&rfHandle, NULL, RSC_READONLY);

    /*	Register messages list ids to be used for prompts or error messages	*/
    mdlState_registerStringIds (STRINGLISTID_Commands, STRINGLISTID_Prompts);

    /*	Register commands */
    mdlSystem_registerCommandNumbers (s_commandNumbers);
    mdlParse_loadCommandTable (NULL);
    }
