/*--------------------------------------------------------------------------------------+
|
|     $Source: MstnExamples/View/DisplayRule/displayrulecmd.r $
|
|  $Copyright: (c) 2018 Bentley Systems, Incorporated. All rights reserved. $
|
+--------------------------------------------------------------------------------------*/
#include <Mstn\MdlApi\rscdefs.r.h>
#include <Mstn\MdlApi\cmdclass.r.h>

#include "displayruleids.h"

#define CT_NONE         0
#define CT_MAIN         1
#define CT_RULES        2
#define CT_CREATE       3
#define CT_REMOVE       4
#define CT_MODIFY       5
#define CT_READ         7

#pragma suppressREQCmds

/*----------------------------------------------------------------------+
 Main command table
+----------------------------------------------------------------------*/
CommandTable CT_MAIN =
    {
    { 1, CT_RULES,        MANIPULATION,        REQ,            "DISPLAYRULE" },
    };

CommandTable CT_RULES =
    {
    { 1, CT_CREATE,       MANIPULATION,        REQ,            "CREATE" },
    { 2, CT_REMOVE,       MANIPULATION,        REQ,            "DELETE" },
    { 3, CT_MODIFY,       MANIPULATION,        REQ,            "MODIFY" },
    { 4, CT_READ,         MANIPULATION,        REQ,            "READ"   },
    };

CommandTable CT_CREATE =
    {
    { 1, CT_NONE,         INHERIT,             NONE,           "RULE",          CMDNAME_DisplayRuleCreate    },
    { 2, CT_NONE,         INHERIT,             DEF,            "RULEITEMTYPE",       CMDNAME_DisplayRuleCreate },
    { 3, CT_NONE,         INHERIT,             DEF,            "RULESET",       CMDNAME_DisplayRuleSetCreate },
    };

CommandTable CT_REMOVE =
    {
    { 1, CT_NONE,         INHERIT,             DEF,            "RULESET",       CMDNAME_DisplayRuleSetDelete },
    { 2, CT_NONE,         INHERIT,             NONE,           "RULE",          CMDNAME_DisplayRuleDelete    },
    };

CommandTable CT_MODIFY =
    {
    { 1, CT_NONE,         INHERIT,             DEF,            "RULE",          CMDNAME_DisplayRuleModify },
    };

CommandTable CT_READ =
    {
    { 1, CT_NONE,         INHERIT,             DEF,            "RULE",          CMDNAME_DisplayRuleRead },
    };


/*-----------------------------------------------------------------------
 Setup for native code only MDL app

 Register Application and DLL
-----------------------------------------------------------------------*/
#define DLLAPP_PRIMARY 1

DllMdlApp DLLAPP_PRIMARY =
    {
    L"DISPLAYRULE", L"displayrule" // taskid, dllName
    }